/*
  idx_list.c
  Quick and dirty linked lists of integer indices
*/
#include <stdlib.h>
#include "idx_list.h"

/* external in triangles.c */
int error_exit(char *message1,char *message2);
/*******/
void init_list(INDEX_LIST *L){
     L->length=0;
     L->first=NULL;
     L->last=NULL;
}

INDEX_LIST * newlist(){
     INDEX_LIST *newL=malloc(sizeof(INDEX_LIST));
     if(newL==NULL) return NULL;
     init_list(newL);
     return newL;
}
void kill_list(INDEX_LIST *L){
     INDEX_LIST_ENTRY *thisentry;
     if(L==NULL) return;
     thisentry=L->first;
     while(thisentry!=NULL){
           INDEX_LIST_ENTRY *nextentry=thisentry->next;
           free(thisentry);
           thisentry=nextentry;
     }
}

void destroy_list(INDEX_LIST *L){

     if(L==NULL) return;
     kill_list(L);
     free(L);
     L=NULL;
}

void remove_index_from_list(INDEX_LIST *L, int index){
    INDEX_LIST_ENTRY *curentry=L->first;
    INDEX_LIST_ENTRY *preventry=NULL;
    INDEX_LIST_ENTRY *nextentry=NULL;
    while(curentry!=NULL){
       nextentry=curentry->next;
       if(curentry->index==index){
           if(preventry){
               preventry->next=nextentry;
           }
           else{
               L->first=nextentry;
           }
           free(curentry);
       }
       else{
           preventry=curentry;
       }
       curentry=nextentry;
    }
}

void add_index_to_list(INDEX_LIST *L,int index){
    INDEX_LIST_ENTRY *oldlast=L->last;

    INDEX_LIST_ENTRY *newentry=malloc(sizeof(INDEX_LIST_ENTRY));
    if(newentry==NULL){
       error_exit("memory allocation error in add_index_to_list",NULL);
    }
    if(L->first==NULL){
        L->first=newentry;
    }
    L->last=newentry;
    newentry->next=NULL;
    if(oldlast)
       oldlast->next=newentry;
    newentry->index=index;
    L->length++;
}

