/*
*  triangles.h
*
*/
#define BUILD_NUMBER 150



#define UNUSED __attribute__ ((unused))
#define RND ((float)rand()/(float)RAND_MAX)


#define LEFT 0
#define RIGHT 1

#define XY 1
#define ZY 2
#define XZ 3

#define X 0
#define Y 1
#define Z 2

/* file saving */
#define TRI 0
#define POV 1
#define POVSMOOTH 2
#define MESH2FLAT 3
#define MESH2SMOOTH 4

#define RAW 5
#define RAWSMOOTH 6
#define PCM1 7
#define PCM1SMOOTH 8
#define WRL 9
#define FE 10
#define FES 11
/**********/

typedef struct VTX
{
   float x, y, z;
   int flags;
} VTX;

typedef struct VECTOR
{
   float x, y, z;
} VECTOR;

typedef struct TRIANGLE
{
   VTX *vtxlist;
   int v1, v2, v3;
   int oflag;
} TRIANGLE;

typedef struct EDGE
{
  int v1,v2;
  int t1,t2;
  int f;
  int midindex;
} EDGE;

/*----*/
typedef struct SHAPE             /* store position of a shape */
{
   float x, y, z;                /* x, y, z position */
   float rx, ry, rz;             /* rotations */
   float dz;                     /* speed of movement */
   float drx, dry, drz;          /* speed of rotation */
   float scale;
} SHAPE;

typedef struct MESH
{

  int num_vertices_allocated;
  int num_faces_allocated;
  int num_edges_allocated;
  
  int num_vertices;
  int num_faces;
  int num_edges;
  
  SHAPE shape;

  VTX * points;
  TRIANGLE * faces;

  VTX * output_points;
  TRIANGLE * output_faces;

  EDGE * edges;

}MESH;
